/*//////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                            //
//  WinTypes.H                                       Falcon External Gateway (FEG)            //
//                                                                                            //
//  PURPOSE:                                                                                  //
//      The necessary definitions from Windows.H                                              //
//                                                                                            //
//  Changes:                                                                                  //
//                                                                                            //
//                              Liraz Systems &  Level 8 - Copyrights                         //
//////////////////////////////////////////////////////////////////////////////////////////////*/
#ifndef _INC_WINDOWS
#define _INC_WINDOWS

#include <string.h>
#ifdef _MSC_VER
#undef _MSC_VER
#endif

#define _MSC_VER 1000

#define FALSE 0
#define TRUE  1

#define INFINITE  0xFFFFFFFF

/*typedef wchar_t WCHAR;    // wc,   16-bit UNICODE character */
typedef char WCHAR;    
typedef char *BSTR;
typedef char *PSTR, *LPSTR;
typedef const char *PCSTR, *LPCSTR;
typedef WCHAR *PWSTR, *LPWSTR;
typedef const WCHAR *PCWSTR, *LPCWSTR;

typedef void VOID;
typedef void *PVOID;    
typedef void *LPVOID;    
typedef unsigned int  BOOL,UINT;
typedef unsigned char BYTE;
typedef unsigned short USHORT;
typedef unsigned char UCHAR;
typedef long LONG;
typedef unsigned long ULONG;
typedef LONG SCODE;
typedef ULONG PROPID;
typedef unsigned short WORD;
typedef unsigned long DWORD;
typedef void * HMODULE;
typedef DWORD* PDWORD, *LPDWORD;
typedef double DATE;
typedef PVOID HANDLE, *PHANDLE;
typedef LONG HRESULT;
typedef HANDLE HWND;

typedef int  *LPINT;




typedef struct _OVERLAPPED {
    DWORD   Internal;
    DWORD   InternalHigh;
    DWORD   Offset;
    DWORD   OffsetHigh;
    HANDLE  hEvent;
} OVERLAPPED, *POVERLAPPED;
typedef POVERLAPPED LPOVERLAPPED;

typedef short VARIANT_BOOL;
#define __RPC_FAR

typedef DWORD SECURITY_INFORMATION, *PSECURITY_INFORMATION;
typedef void *PSECURITY_ATTRIBUTES;
typedef PVOID PSECURITY_DESCRIPTOR;     

typedef struct  tagBLOB {
  ULONG cbSize;
  BYTE __RPC_FAR *pBlobData;
} BLOB;

#define CALLBACK
#define APIENTRY WINAPI
#define PASCAL
#define INOUT
#define IN
#define OUT
#define FAR

#define WINAPI   __stdcall
typedef int (FAR WINAPI *FARPROC)();

#ifndef NULL
#ifdef __cplusplus
#define NULL    0
#else
#define NULL    ((void *)0)
#endif
#endif

#ifndef GUID_DEFINED
#define GUID_DEFINED

typedef struct _GUID {          /* size is 16 */
  DWORD  Data1;
  WORD   Data2;
  WORD   Data3;
  BYTE  Data4[8];
} GUID;
typedef GUID __RPC_FAR *PGUID;
typedef PGUID LPGUID;

#endif /* !GUID_DEFINED */

typedef GUID CLSID;

      /* size is 2 */
typedef WCHAR OLECHAR;

      /* size is 4 */
typedef /* [string] */ OLECHAR __RPC_FAR *POLESTR;
typedef POLESTR LPOLESTR;



/*
 * VARENUM usage key,
 *
 * * [V] - may appear in a VARIANT
 * * [T] - may appear in a TYPEDESC
 * * [P] - may appear in an OLE property set
 * * [S] - may appear in a Safe Array
 *
 *
 *  VT_EMPTY            [V]   [P]     nothing                     
 *  VT_NULL             [V]           SQL style Null              
 *  VT_I2               [V][T][P][S]  2 byte signed int           
 *  VT_I4               [V][T][P][S]  4 byte signed int           
 *  VT_R4               [V][T][P][S]  4 byte real                 
 *  VT_R8               [V][T][P][S]  8 byte real                 
 *  VT_CY               [V][T][P][S]  currency                    
 *  VT_DATE             [V][T][P][S]  date                        
 *  VT_BSTR             [V][T][P][S]  binary string               
 *  VT_DISPATCH         [V][T]   [S]  IDispatch FAR*              
 *  VT_ERROR            [V][T]   [S]  SCODE                       
 *  VT_BOOL             [V][T][P][S]  True=-1, False=0            
 *  VT_VARIANT          [V][T][P][S]  VARIANT FAR*                
 *  VT_UNKNOWN          [V][T]   [S]  IUnknown FAR*               
 *  VT_I1                  [T]        signed char                 
 *  VT_UI1              [V][T]   [S]  unsigned char               
 *  VT_UI2                 [T]        unsigned short              
 *  VT_UI4                 [T]        unsigned short              
 *  VT_I8                  [T][P]     signed 64-bit int           
 *  VT_UI8                 [T]        unsigned 64-bit int         
 *  VT_INT                 [T]        signed machine int          
 *  VT_UINT                [T]        unsigned machine int        
 *  VT_VOID                [T]        C style void                
 *  VT_HRESULT             [T]                                    
 *  VT_PTR                 [T]        pointer type                
 *  VT_SAFEARRAY           [T]        (use VT_ARRAY in VARIANT)   
 *  VT_CARRAY              [T]        C style array               
 *  VT_USERDEFINED         [T]        user defined type           
 *  VT_LPSTR               [T][P]     null terminated string      
 *  VT_LPWSTR              [T][P]     wide null terminated string 
 *  VT_FILETIME               [P]     FILETIME                    
 *  VT_BLOB                   [P]     Length prefixed bytes       
 *  VT_STREAM                 [P]     Name of the stream follows  
 *  VT_STORAGE                [P]     Name of the storage follows 
 *  VT_STREAMED_OBJECT        [P]     Stream contains an object   
 *  VT_STORED_OBJECT          [P]     Storage contains an object  
 *  VT_BLOB_OBJECT            [P]     Blob contains an object     
 *  VT_CF                     [P]     Clipboard format            
 *  VT_CLSID                  [P]     A Class ID                  
 *  VT_VECTOR                 [P]     simple counted array        
 *  VT_ARRAY            [V]           SAFEARRAY*                  
 *  VT_BYREF            [V]                                       
 */
      /* size is 2 */

enum VARENUM
    { VT_EMPTY  = 0,
  VT_NULL = 1,
  VT_I2 = 2,
  VT_I4 = 3,
  VT_R4 = 4,
  VT_R8 = 5,
  VT_CY = 6,
  VT_DATE = 7,
  VT_BSTR = 8,
  VT_DISPATCH = 9,
  VT_ERROR  = 10,
  VT_BOOL = 11,
  VT_VARIANT  = 12,
  VT_UNKNOWN  = 13,
  VT_I1 = 16,
  VT_UI1  = 17,
  VT_UI2  = 18,
  VT_UI4  = 19,
  VT_I8 = 20,
  VT_UI8  = 21,
  VT_INT  = 22,
  VT_UINT = 23,
  VT_VOID = 24,
  VT_HRESULT  = 25,
  VT_PTR  = 26,
  VT_SAFEARRAY  = 27,
  VT_CARRAY = 28,
  VT_USERDEFINED  = 29,
  VT_LPSTR  = 30,
  VT_LPWSTR = 31,
  VT_FILETIME = 64,
  VT_BLOB = 65,
  VT_STREAM = 66,
  VT_STORAGE  = 67,
  VT_STREAMED_OBJECT  = 68,
  VT_STORED_OBJECT  = 69,
  VT_BLOB_OBJECT  = 70,
  VT_CF = 71,
  VT_CLSID  = 72
    };
#endif
      /* size is 2 */
#define VT_VECTOR ( 0x1000 )

      /* size is 2 */
#define VT_ARRAY  ( 0x2000 )

      /* size is 2 */
#define VT_BYREF  ( 0x4000 )

      /* size is 2 */
#define VT_RESERVED ( 0x8000 )

#ifndef _VARTYPE_DEFINED
#define _VARTYPE_DEFINED
      /* size is 2 */
typedef unsigned short VARTYPE;

#ifndef __IUnknown_Already_Defined__
typedef void IUnknown;
#endif //__IUnknown_Already_Defined__
typedef LONG ISOLEVEL;
#define MAX_TRAN_DESC 50
typedef void BOID;
typedef struct {
  ULONG ulTimeout;
  UCHAR szDescription[MAX_TRAN_DESC];
} XACTOPT;


/*//////////////////////////////////////////////////////////////////////////////////////////////
// The folloing are definitions taken from the Windows NT wincrypt.h                          //
//////////////////////////////////////////////////////////////////////////////////////////////*/

// ALG_ID crackers
#define GET_ALG_CLASS(x)                (x & (7 << 13))
#define GET_ALG_TYPE(x)                 (x & (15 << 9))
#define GET_ALG_SID(x)                  (x & (511))

// Algorithm classes
#define ALG_CLASS_ANY                   (0)
#define ALG_CLASS_SIGNATURE             (1 << 13)
#define ALG_CLASS_MSG_ENCRYPT           (2 << 13)
#define ALG_CLASS_DATA_ENCRYPT          (3 << 13)
#define ALG_CLASS_HASH                  (4 << 13)
#define ALG_CLASS_KEY_EXCHANGE          (5 << 13)

// Algorithm types
#define ALG_TYPE_ANY                    (0)
#define ALG_TYPE_DSS                    (1 << 9)
#define ALG_TYPE_RSA                    (2 << 9)
#define ALG_TYPE_BLOCK                  (3 << 9)
#define ALG_TYPE_STREAM                 (4 << 9)
#define ALG_TYPE_DH                     (5 << 9)
#define ALG_TYPE_SSL3                   (6 << 9)

// Generic sub-ids
#define ALG_SID_ANY                     (0)

// Some RSA sub-ids
#define ALG_SID_RSA_ANY                 0
#define ALG_SID_RSA_PKCS                1
#define ALG_SID_RSA_MSATWORK            2
#define ALG_SID_RSA_ENTRUST             3
#define ALG_SID_RSA_PGP                 4

// Some DSS sub-ids
//
#define ALG_SID_DSS_ANY                 0
#define ALG_SID_DSS_PKCS                1
#define ALG_SID_DSS_DMS                 2

// Block cipher sub ids
// DES sub_ids
#define ALG_SID_DES                     1
#define ALG_SID_3DES                    3
#define ALG_SID_DESX                    4
#define ALG_SID_IDEA                    5
#define ALG_SID_CAST                    6
#define ALG_SID_SAFERSK64               7
#define ALD_SID_SAFERSK128              8
#define ALG_SID_3DES_112                9
#define ALG_SID_CYLINK_MEK              12

// Fortezza sub-ids
#define ALG_SID_SKIPJACK                10
#define ALG_SID_TEK                     11

// KP_MODE
#define CRYPT_MODE_CBCI                 6       // ANSI CBC Interleaved
#define CRYPT_MODE_CFBP                 7       // ANSI CFB Pipelined
#define CRYPT_MODE_OFBP                 8       // ANSI OFB Pipelined
#define CRYPT_MODE_CBCOFM               9       // ANSI CBC + OF Masking
#define CRYPT_MODE_CBCOFMI              10      // ANSI CBC + OFM Interleaved

// RC2 sub-ids
#define ALG_SID_RC2                     2

// Stream cipher sub-ids
#define ALG_SID_RC4                     1
#define ALG_SID_SEAL                    2

// Diffie-Hellman sub-ids
#define ALG_SID_DH_SANDF                1
#define ALG_SID_DH_EPHEM                2
#define ALG_SID_AGREED_KEY_ANY          3
#define ALG_SID_KEA                     4

// Hash sub ids
#define ALG_SID_MD2                     1
#define ALG_SID_MD4                     2
#define ALG_SID_MD5                     3
#define ALG_SID_SHA                     4
#define ALG_SID_SHA1                    4
#define ALG_SID_MAC                     5
#define ALG_SID_RIPEMD                  6
#define ALG_SID_RIPEMD160               7
#define ALG_SID_SSL3SHAMD5              8

// SSL3 sub ids
#define ALG_SID_PREMASTER               1
#define ALG_SID_MAC_KEY                 2

// Our silly example sub-id
#define ALG_SID_EXAMPLE                 80

#ifndef ALGIDDEF
#define ALGIDDEF
typedef unsigned int ALG_ID;
#endif

// algorithm identifier definitions
#define CALG_MD2        (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_MD2)
#define CALG_MD4        (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_MD4)
#define CALG_MD5        (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_MD5)
#define CALG_SHA        (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_SHA)
#define CALG_SHA1       (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_SHA1)
#define CALG_MAC        (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_MAC)
#define CALG_RSA_SIGN   (ALG_CLASS_SIGNATURE | ALG_TYPE_RSA | ALG_SID_RSA_ANY)
#define CALG_DSS_SIGN   (ALG_CLASS_SIGNATURE | ALG_TYPE_DSS | ALG_SID_DSS_ANY)
#define CALG_RSA_KEYX   (ALG_CLASS_KEY_EXCHANGE|ALG_TYPE_RSA|ALG_SID_RSA_ANY)
#define CALG_DES        (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_BLOCK|ALG_SID_DES)
#define CALG_3DES_112   (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_BLOCK|ALG_SID_3DES_112)
#define CALG_3DES       (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_BLOCK|ALG_SID_3DES)
#define CALG_RC2        (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_BLOCK|ALG_SID_RC2)
#define CALG_RC4        (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_STREAM|ALG_SID_RC4)
#define CALG_SEAL       (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_STREAM|ALG_SID_SEAL)
#define CALG_DH_SF              (ALG_CLASS_KEY_EXCHANGE|ALG_TYPE_DH|ALG_SID_DH_SANDF)
#define CALG_DH_EPHEM   (ALG_CLASS_KEY_EXCHANGE|ALG_TYPE_DH|ALG_SID_DH_EPHEM)
#define CALG_AGREEDKEY_ANY (ALG_CLASS_KEY_EXCHANGE|ALG_TYPE_DH|ALG_SID_AGREED_KEY_ANY)
#define CALG_KEA_KEYX   (ALG_CLASS_KEY_EXCHANGE|ALG_TYPE_DH|ALG_SID_KEA)
#define CALG_SKIPJACK   (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_BLOCK|ALG_SID_SKIPJACK)
#define CALG_TEK        (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_BLOCK|ALG_SID_TEK)
#define CALG_CYLINK_MEK (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_BLOCK|ALG_SID_CYLINK_MEK)
#define CALG_SSL3_PREMASTER (ALG_CLASS_MSG_ENCRYPT|ALG_TYPE_SSL3|ALG_SID_PREMASTER)
#define CALG_SSL3_MAC_KEY (ALG_CLASS_MSG_ENCRYPT|ALG_TYPE_SSL3|ALG_SID_MAC_KEY)


//
// CryptSetProvParam
//
#define PP_CLIENT_HWND          1

#define PROV_RSA_FULL           1
#define PROV_RSA_SIG            2
#define PROV_DSS                3
#define PROV_FORTEZZA           4
#define PROV_MS_EXCHANGE        5
#define PROV_SSL                6

//
// STT defined Providers
//
#define PROV_STT_MER                    7
#define PROV_STT_ACQ                    8
#define PROV_STT_BRND                   9
#define PROV_STT_ROOT                   10
#define PROV_STT_ISS                    11

//
// Provider friendly names
//
#define MS_DEF_PROV_A       "Microsoft Base Cryptographic Provider v1.0"
#define MS_DEF_PROV_W       L"Microsoft Base Cryptographic Provider v1.0"
#ifdef UNICODE
#define MS_DEF_PROV         MS_DEF_PROV_W
#else
#define MS_DEF_PROV         MS_DEF_PROV_A
#endif

#define MS_ENHANCED_PROV_A       "Microsoft Enhanced Cryptographic Provider v1.0"
#define MS_ENHANCED_PROV_W       L"Microsoft Enhanced Cryptographic Provider v1.0"
#ifdef UNICODE
#define MS_ENHANCED_PROV         MS_ENHANCED_PROV_W
#else
#define MS_ENHANCED_PROV         MS_ENHANCED_PROV_A
#endif

/*/////////////////////////////////////////////////////////////////////////////////////////////
// End of definitions taken from the Windows NT wincrypt.h                                    //
//////////////////////////////////////////////////////////////////////////////////////////////*/



#endif
